#
# * This is the Tcl client for memcached - a distributed memory cache daemon.
# * More information is available at http://www.danga.com/memcached/



# procedure to check for the availability and status of the server
#returns the socket on success else returns false on failure


#All the basic routines for checking the server 
#global variable for debug flag

#!/usr/bin/tclsh

#TODOS

# Get is not working
# No evaluation of arguments



global Debug

namespace eval memcache { 

   proc register_server {host port  { debug 1 } } {
	set ::Debug $debug 
	if [ catch { set out [ exec ps -A | grep memcached ] } res ] {
		if { $::Debug == 1} {
			puts "The Memcache Deamon does'nt seem to be running."
			puts "Start the deamon and re run the script ."
			set server_status_flag  false	
#			return 	$server_status_flag			
	        	exit 0
		      }
			exit 0
	} else  {
	       if [ catch { set socket_stat [ socket -async $host $port ] } res ] {
                   if { $::Debug == 1 } {
                    puts "The Connection to Host:$host on Port:$port has been refused.Please check that the host and the port number  are set correctly."
		   }
		   set server_status_flag  false
                   return  $server_status_flag
                } else {
	            if { $::Debug == 1 } {
		      puts "Connection established successfully"                        
		    }
	            fconfigure $socket_stat -buffering line 
                    return $socket_stat
	       }
	 }
    }


#procedure to consider operations of data in the cache

   proc mc_create { replace_p } {
       if { $replace_p == "t" } {
#set	   
       } else {
#add       
       }
   }
 
   


   proc mc_add { socket_handle key flag exp_time no_bytes data} {
            mc_set $socket_handle "add" $key $flag $exp_time $no_bytes $data
   }

   proc mc_new { socket_handle key flag exp_time no_bytes data} {
       mc_set $socket_handle "set" $key $flag $exp_time $no_bytes $data
   }

   proc mc_replace { socket_handle key flag exp_time no_bytes data} {
       mc_set $socket_handle "replace" $key $flag $exp_time $no_bytes $data
   }



# cmd can be add,replace and set : refer help files for further details
				

  proc mc_set {socket_handle cmd key  flag   exp_time  no_bytes   data  } {
      if [catch { puts $socket_handle "$cmd $key $flag $exp_time $no_bytes\r\n$data" } res ] {
	  puts "Unavailable Socket"
	  return false
	} else {
	    set output [ gets $socket_handle ]
	    if { $::Debug == 1	  } {
		puts "$key is $output"
	    }
	} 	
  }
		

#procedure to delete a key from the server with an optional time period
#the default time period is 0 secs

   proc mc_del { socket_handle key { exp_time 0 } } {
       if [ catch { puts $socket_handle "delete $key $exp_time" } ] {
	   puts "Unavailable socket."
       } else {
	   set output ""
	   set  output [ gets $socket_handle ] 
	   puts "The key $key has been $output"
       }

   } 


#procedure to get the  data based on the key
   proc mc_get { socket_handle key } {
       if [ catch { puts $socket_handle "get $key" } res ] {
	  puts "Unavailable Socket"
	  return false
	} else {
	  set output ""
	  while { [set  output [ gets $socket_handle ] ] !="END" } {
	     puts $output
	   }	
	}
   }

#procedure to get statistics of the server
   proc mc_stats { socket_handle } {
	if [ catch { puts $socket_handle "stats" }  res ] {
	   puts "Unavialble socket"
	   return false
	} else {
	   set output ""
           while { [set  output [ gets $socket_handle ] ] !="END" } {
                puts $output 
           }
	}

   }

#procedure to increment the data based on the key
#optional value "val by which to increment the data
#default value is 1
   proc mc_incr { socket_handle key { amount 1 } } {
       puts $socket_handle "incr $key $amount\r\n"
       set output [ gets $socket_handle]
       puts $output
   }


   proc mc_decr { socket_handle key { amount 1 } } {
    puts $socket_handle "decr $key $amount\r\n"
    set output [ gets $socket_handle]
    puts $output
   }



#procedure to flush all the values in the cache
  proc mc_flush { socket_handle } {
    puts $socket_handle "flush_all"
  }
}

		